%define  ver  1.12.1599.102
%define  ibus_ver  1.4.2

%define  fcitx_mozc  1
%define  fcitx_ver   4.2.8.3
%define  fcitx_patch_rev  1
%define  fcitx_mozc_ver   %{version}.%{fcitx_patch_rev}

%define  uim_mozc    1
%define  uim_ver     1.8.6
%define  macuim_ver  r328

%define  zipcode_date  20131031

%define  protobuf_ver  2.5.0
%define  gyp_ver  r1732


Name:     mozc
Summary:  GoogleIME open source version
Summary(ja):  Google日本語入力オープンソース版
Version:  %{ver}
Release:  %mkrel 1
License:  BSD-like
Group:    System/Internationalization
URL:      http://code.google.com/p/mozc/
Source0:  http://mozc.googlecode.com/files/mozc-%{version}.tar.xz

# zip code data from
# http://www.post.japanpost.jp/zipcode/download.html
Source2:  zip_code-%{zipcode_date}.tar.xz

# desktop entries
Source21:  mozc-preference.desktop.in
Source22:  mozc-dict.desktop.in

# ibusのツールバー（言語バー）のボタンの表示を日本語化する
Patch10:  mozc-1.10.1390.102-ibus-toolbar.patch

# third party source
Source100:  protobuf-%{protobuf_ver}.tar.xz
Source101:  gyp-%{gyp_ver}.tar.xz

%if %{uim_mozc}
# MacUIM include uim-mozc for linux
# http://code.google.com/p/macuim/
Source200:  macuim-%{macuim_ver}.tar.xz
# uim-mozc のツールバーの設定ボタンの表示を日本語化する
Patch200:  uim-mozc-svn302-toolbar.patch
%endif

%if %{fcitx_mozc}
Source210:  http://download.fcitx-im.org/fcitx-mozc/fcitx-mozc-icons.tar.xz
Patch210:  http://download.fcitx-im.org/fcitx-mozc/fcitx-mozc-%{fcitx_mozc_ver}.patch
%endif

BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires:  python
BuildRequires:  gcc-c++
BuildRequires:  openssl-devel
BuildRequires:  dbus-devel
BuildRequires:  glib2-devel
BuildRequires:  libgtk+2-devel
BuildRequires:  libxt-devel
BuildRequires:  libxcb-devel
#BuildRequires:  gyp

Requires:  mozc-tools = %{version}-%{release}
Provides:  mozcserver = %{version}
Conflicts: mozc+sawadict, mozc+utdict

%description
Mozc is a Japanese Input Method Editor (IME) designed for multi-platform such as Chromium OS, Windows, Mac and Linux.
Mozc originates from Google Japanese Input.
This package contain mozc_server.

After installation of this package should re-log in. 

%description -l ja
Mozc はマルチプラットフォーム対応の日本語入力システムで、「Google 日本語入力」をオープンソース化したものです。
このパッケージは、Mozc の核となる変換エンジン (mozc_server) を提供します。

※ インストール後は再ログインしてください。

# --------------------------------------------------------------

%package tools
Summary:  Mozc utilities
Summary(ja):  Mozc の為のツール
Group:    System/Internationalization
BuildRequires:  libqt4-devel
BuildRequires:  zinnia-devel
Requires:  mozc = %{version}-%{release}
Requires:  qt4-common
Requires:  %{_lib}qtgui4
Requires:  %{_lib}qtcore4
Requires:  %{_lib}zinnia0
Requires:  tegaki-zinnia-japanese
Requires(post,postun):  desktop-file-utils
Conflicts: mozc+sawadict-tools, mozc+utdict-tools

%description tools
This package contain Mozc GUI utilities (mozc_tool), such as the configuration dialog, user dictionary tool and about dialog.

%description tools -l ja
このパッケージには、Mozc の各種設定と辞書管理を行うための GUI 版ツール (mozc_tool) が含まれています。

# ---------------------------------------------------------------

%package -n ibus-mozc
Summary:  IBus engine module for Mozc.
Summary(ja):  IBus 用 Mozc エンジン
Group:    System/Internationalization
BuildRequires:  ibus-devel >= %{ibus_ver}
Requires:  ibus >= %{ibus_ver}
Requires:  mozcserver = %{version}

%description -n ibus-mozc
This package contain IBus engine module for Mozc.

Please log in again after you install this package.

%description -n ibus-mozc -l ja
このパッケージには、Mozc の IBus 用エンジンモジュールが含まれています。
このパッケージをインストールすることで、IBus で Mozc を使用できる様になります。

※ インストール後は再ログインしてください。

# ---------------------------------------------------------------

%package -n emacs-mozc
Summary:   Mozc for Emacs
Summary(ja):  Emacs 用 Mozc クライアント
Group:    System/Internationalization
BuildRequires:  emacs-common
Requires:  emacs-common
Requires:  mozcserver = %{version}

%description -n emacs-mozc
This package contain emacs helper module for mozc.

Please log in again after you install this package.

%description -n emacs-mozc -l ja
このパッケージには、emacs 用の Mozc ヘルパーモジュールが含まれています。

※ インストール後は再ログインしてください。

# --------------------------------------------------------------

%if %{uim_mozc}
%package -n uim-mozc
Summary:  Uim plugin for Mozc
Summary(ja):  Uim 用 Mozc プラグイン
Group:    System/Internationalization
BuildRequires:  uim-devel >= %{uim_ver}
Requires:  uim >= %{uim_ver}
Requires:  mozcserver = %{version}
Requires(post,postun):  uim >= %{uim_ver}

%description -n uim-mozc
This package contain Uim plugin for Mozc.

Please restart the computer after you install this package.

%description -n uim-mozc -l ja
Uim で Mozc を使用するためのプラグインです。

※ インストール後はコンピューターを再起動してください。
%endif

# --------------------------------------------------------------

%if %{fcitx_mozc}
%package -n fcitx-mozc
Summary:   Mozc engine for fcitx
Group:     System/Internationalization
BuildRequires:  fcitx-devel >= %{fcitx_ver}
Requires:  mozcserver = %{version}
Requires:  fcitx >= %{fcitx_ver}

%description -n fcitx-mozc
fcitx-mozc provides client part of the Mozc input method.

Please log in again after you install this package.
%endif


# --------------------------------------------------------------

%prep
%setup -q -n mozc-%{version}
%patch10 -p0

## third party source
pushd third_party
# protobuf
tar -xaf %{SOURCE100}
mv protobuf-%{protobuf_ver} protobuf
# gyp
rm -rf gyp
tar -xaf %{SOURCE101}
mv gyp-%{gyp_ver} gyp
popd

# add zip code dictionary
cd data/dictionary_oss
tar -xaf %{SOURCE2}
python ../../dictionary/gen_zip_code_seed.py --zip_code=KEN_ALL.CSV --jigyosyo=JIGYOSYO.CSV >> dictionary09.txt
cd -

# uim-mozc
%if %{uim_mozc}
tar -xaf %{SOURCE200} macuim-trunk/Mozc
%patch200 -p0
cp -r macuim-trunk/Mozc/uim ./unix/
patch -p0 < macuim-trunk/Mozc/mozc-kill-line.diff
%ifarch x86_64
sed -i 's|/usr/lib|/usr/lib64|g' macuim-trunk/Mozc/scm/mozc-custom.scm
%endif
%endif

# fcitx-mozc
%if %{fcitx_mozc}
%patch210 -p2
%endif

# ---------------------------------------------------------------

%build
export GYP_DEFINES="ibus_mozc_path=%{_libdir}/ibus-mozc/ibus-engine-mozc ibus_mozc_icon_path=%{_datadir}/ibus-mozc/product_icon.png document_dir=%{_datadir}/doc/mozc zinnia_model_file=%{_datadir}/tegaki/models/zinnia/handwriting-ja.model"

python build_mozc.py gyp --server_dir=%{_libdir}/mozc

python build_mozc.py build_tools -c Release %{?_smp_mflags}
python build_mozc.py build -c Release %{?_smp_mflags} \
  server/server.gyp:mozc_server \
  renderer/renderer.gyp:mozc_renderer \
  gui/gui.gyp:mozc_tool \
  unix/ibus/ibus.gyp:ibus_mozc \
%if %{uim_mozc}
  unix/uim/uim.gyp:uim-mozc \
%endif
%if %{fcitx_mozc}
  unix/fcitx/fcitx.gyp:fcitx-mozc \
%endif
  unix/emacs/emacs.gyp:mozc_emacs_helper

# --------------------------------------------------------------

%install
rm -rf $RPM_BUILD_ROOT

## install mozc_server, mozc_renderer and mozc_tool
mkdir -p $RPM_BUILD_ROOT%{_libdir}/mozc
install -m755 ./out_linux/Release/mozc_server $RPM_BUILD_ROOT%{_libdir}/mozc/mozc_server
install -m755 ./out_linux/Release/mozc_renderer $RPM_BUILD_ROOT%{_libdir}/mozc/mozc_renderer
install -m755 ./out_linux/Release/mozc_tool $RPM_BUILD_ROOT%{_libdir}/mozc/mozc_tool


## install ibus-mozc
install -D -m755 ./out_linux/Release/ibus_mozc $RPM_BUILD_ROOT%{_libdir}/ibus-mozc/ibus-engine-mozc
install -D -m644 ./out_linux/Release/obj/gen/unix/ibus/mozc.xml $RPM_BUILD_ROOT%{_datadir}/ibus/component/mozc.xml

## install icons for ibus-mozc
pushd data/images/unix
install -D -m644 ime_product_icon_opensource-32.png $RPM_BUILD_ROOT%{_datadir}/ibus-mozc/product_icon.png
install -m644 ../product_icon_32bpp-128.png $RPM_BUILD_ROOT%{_datadir}/ibus-mozc/product_icon-128.png
for i in ui-*.png; do
  install -m644 $i $RPM_BUILD_ROOT%{_datadir}/ibus-mozc/${i//ui-/}
done
popd


## install emacs client
install -D -m644 ./unix/emacs/mozc.el $RPM_BUILD_ROOT%{_datadir}/emacs/site-lisp/emacs-mozc/mozc.el
install -D -m755 ./out_linux/Release/mozc_emacs_helper $RPM_BUILD_ROOT%{_bindir}/mozc_emacs_helper


## install uim-mozc
%if %{uim_mozc}
install -D -m755 ./out_linux/Release/libuim-mozc.so $RPM_BUILD_ROOT%{_libdir}/uim/plugin/libuim-mozc.so
mkdir -p $RPM_BUILD_ROOT%{_datadir}/uim
install -m644 macuim-trunk/Mozc/scm/*.scm $RPM_BUILD_ROOT%{_datadir}/uim/

## install icons for uim_mozc
pushd data/images/unix
install -D -m644 ime_product_icon_opensource-32.png $RPM_BUILD_ROOT%{_datadir}/uim/pixmaps/mozc.png
install -m644 ../product_icon_32bpp-128.png $RPM_BUILD_ROOT%{_datadir}/uim/pixmaps/mozc-128.png
install -m644 ui-tool.png $RPM_BUILD_ROOT%{_datadir}/uim/pixmaps/mozc_tool_selector.png
install -m644 ui-properties.png $RPM_BUILD_ROOT%{_datadir}/uim/pixmaps/mozc_tool_config_dialog.png
install -m644 ui-dictionary.png $RPM_BUILD_ROOT%{_datadir}/uim/pixmaps/mozc_tool_dictionary_tool.png
popd
%endif


## install fcitx-mozc
%if %{fcitx_mozc}
install -D -m755 ./out_linux/Release/fcitx-mozc.so $RPM_BUILD_ROOT%{_libdir}/fcitx/fcitx-mozc.so
# conf file
install -D -m644 ./unix/fcitx/fcitx-mozc.conf $RPM_BUILD_ROOT%{_datadir}/fcitx/addon/fcitx-mozc.conf
install -D -m644 ./unix/fcitx/mozc.conf $RPM_BUILD_ROOT%{_datadir}/fcitx/inputmethod/mozc.conf
# mo
install -D -m644 ./out_linux/Release/obj/gen/unix/fcitx/po/ja.mo $RPM_BUILD_ROOT%{_datadir}/locale/ja/LC_MESSAGES/fcitx-mozc.mo
# icons
mkdir -p $RPM_BUILD_ROOT%{_datadir}/fcitx/mozc/icon
tar -xaf %{SOURCE210}
cp fcitx-mozc-icons/*.png $RPM_BUILD_ROOT%{_datadir}/fcitx/mozc/icon/
%endif


## install desktop entries for MozcTool
mkdir $RPM_BUILD_ROOT%{_datadir}/applications
sed -e 's|@LIBDIR@|%{_libdir}|' < %{SOURCE21} > $RPM_BUILD_ROOT%{_datadir}/applications/mozc-preference.desktop
sed -e 's|@LIBDIR@|%{_libdir}|' < %{SOURCE22} > $RPM_BUILD_ROOT%{_datadir}/applications/mozc-dict.desktop

## install icons for desktop entries
pushd data/images/unix
install -D -m644 ui-properties.png $RPM_BUILD_ROOT%{_datadir}/icons/mozc-properties.png
install -m644 ui-dictionary.png $RPM_BUILD_ROOT%{_datadir}/icons/mozc-dictionary.png
popd


## copyright
cp data/installer/credits_*.html ./
chmod 644 credits_*.html


# --------------------------------------------------------------

%clean
rm -rf $RPM_BUILD_ROOT


%pre
if pgrep -x mozc_server > /dev/null; then
pkill -x mozc_server
fi


%post tools
%update_desktop_database

%postun tools
%clean_desktop_database


%if %{uim_mozc}
%post -n uim-mozc
%{_bindir}/uim-module-manager --register mozc > /dev/null 2>&1

%preun -n uim-mozc
if [ $1 = 0 ] ; then
%{_bindir}/uim-module-manager --unregister mozc > /dev/null 2>&1
fi
%endif

# --------------------------------------------------------------

%files
%defattr(-,root,root,-)
%doc credits_*.html
%{_libdir}/mozc/mozc_server

%files tools
%defattr(-,root,root,-)
%{_libdir}/mozc/mozc_tool
%{_datadir}/applications/*.desktop
%{_datadir}/icons/*.png

%files -n ibus-mozc
%defattr(-,root,root,-)
%{_libdir}/ibus-mozc/ibus-engine-mozc
%{_libdir}/mozc/mozc_renderer
%{_datadir}/ibus/component/mozc.xml
%{_datadir}/ibus-mozc/*.png

%files -n emacs-mozc
%defattr(-,root,root,-)
%{_bindir}/mozc_emacs_helper
%{_datadir}/emacs/site-lisp/emacs-mozc/mozc.el

%if %{uim_mozc}
%files -n uim-mozc
%defattr(-,root,root)
%{_libdir}/uim/plugin/libuim-mozc.so
%{_datadir}/uim/mozc*.scm
%{_datadir}/uim/pixmaps/*.png
%endif

%if %{fcitx_mozc}
%files -n fcitx-mozc
%defattr(-,root,root)
%{_libdir}/fcitx/fcitx-mozc.so
%{_datadir}/fcitx/addon/fcitx-mozc.conf
%{_datadir}/fcitx/inputmethod/mozc.conf
%{_datadir}/fcitx/mozc/icon/*
%{_datadir}/locale/ja/LC_MESSAGES/fcitx-mozc.mo
%endif

# --------------------------------------------------------------

%changelog
* Wed Nov 13 2013 pinoc <vogtpet at gmail.com> 1.12.1599.102-1pclos2013
- imported from tomcat
